Subject: [ltans] Question about RFC 4998 Section 4.2 Archive TimeStamp Generation

From: Satoru Otsubo <[email-masked]>
Date: Sun, 20 Dec 2009 19:53:06 +0900

I am Satoru Otsubo.

In RFC 4998, Section 4.2 Generation, stage 4.,
 there is the following explanation (Page 13, line 1-3):
(If additional hash values are needed, e.g., so that
 all nodes have the same number of children, any data may be
 hashed using H and used.)

But I think, if one node is build from two nodes, no additional hash values are needed.
For example,

(a)
                   h123
                     x
             xxxxxxxxxxxxxxxxxxx
             x                 x 
             x                 x
            h12                x
             x                 x
       xxxxxxxxxxxxx           x
       x           x           x
       x           x           x
       h1         h2          h3

(b)
                       h1234
                         x
             xxxxxxxxxxxxxxxxxxxxxxxxx
             x                       x 
             x                       x
            h12                     h34
             x                       x
       xxxxxxxxxxxxx           xxxxxxxxxxxx
       x           x           x          x
       x           x           x          x
       h1         h2          h3          h4

(c)
                                      h12345
                                        x
                         xxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
                         x                            x
                         x                            x
                       h1234                          x
                         x                            x
             xxxxxxxxxxxxxxxxxxxxxxxxx                x
             x                       x                x
             x                       x                x
            h12                     h34               x
             x                       x                x
       xxxxxxxxxxxxx           xxxxxxxxxxxx           x
       x           x           x          x           x
       x           x           x          x           x
       h1         h2          h3          h4          h5

(d)
                                        h123456
                                           x
                         xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
                         x                                  x
                         x                                  x
                       h1234                                x
                         x                                  x
             xxxxxxxxxxxxxxxxxxxxxxxxx                      x
             x                       x                      x
             x                       x                      x
            h12                     h34                    h56
             x                       x                      x
       xxxxxxxxxxxxx           xxxxxxxxxxxx           xxxxxxxxxxxxx
       x           x           x          x           x           x
       x           x           x          x           x           x
       h1         h2          h3          h4          h5         h6

As shown fig(a),(b),(c),(d), despite the number of datagroups (leaves),
 a root node seems to be always build without additional hash values,
 as long as one node is build from two nodes.

What situation is imagined as a case where additional hash values are needed ?

Thanks in advance.